#ifndef EEBIE_READER_H
#define EEBIE_READER_H

#define EBML_READ_MAXIMUM_DEPTH 128

#include"ebml.h"

#include<stddef.h>
#include<stdint.h>

enum EBMLReaderState {
	EBMLRS_WAITING_FOR_ELEMENT_ID,
	EBMLRS_WAITING_FOR_ELEMENT_LENGTH,
	EBMLRS_WAITING_FOR_ELEMENT_DATA,
};

struct EBMLReader;

typedef EBMLElementType(*EBMLEventEnterElement)(struct EBMLReader*, uint64_t id, uint64_t length);
typedef void(*EBMLEventDataChunk)(struct EBMLReader*, const uint8_t *data, size_t length);
typedef void(*EBMLEventExitElement)(struct EBMLReader*);

typedef struct EBMLReader {
	enum EBMLReaderState state;
	union {
		struct {
			uint64_t id;
			uint64_t length;
			
			EBMLElementType type;
		} inside;
	};
	
	int currentDepth;
	uint64_t stack[EBML_READ_MAXIMUM_DEPTH];
	uint64_t idStack[EBML_READ_MAXIMUM_DEPTH];
	
	EBMLEventEnterElement eventEnterElement;
	EBMLEventDataChunk eventDataChunk;
	EBMLEventExitElement eventExitElement;
	
	void *ud;
} EBMLReader;

void ebml_reader_init(EBMLReader *this);
int ebml_reader_feed(EBMLReader *this, const uint8_t *data, size_t length);

#endif
