#include"pci.h"

#include<stddef.h>
#include"vpm.h"

size_t claimedCount = 0;
uint32_t *claimed;

void pci_init() {
	uint32_t cr3;
	asm volatile("movl %%cr3, %0" : "=r" (cr3) :);
	
	claimed = vpm_map(cr3, VPM_KERNEL, -1, -1, 4096);
}

uint32_t pci_claim(uint32_t cscp) {
	for(int b = 0; b < 256; b++) {
		for(int d = 0; d < 32; d++) {
			for(int f = 0; f < 8; f++) {
				uint32_t id = (b << 16) | (d << 11) | (f << 8);
				if((pci_read(id, 8) & 0xFFFFFF00) == cscp) {
					for(size_t i = 0; i < claimedCount; i++) {
						if(claimed[i] == id) {
							goto cont;
						}
					}
					
					claimed[claimedCount++] = id;
					return id;
				}
cont:;
			}
		}
	}
	return -1;
}

uint32_t pci_read(uint32_t id, uint8_t offset) {
	asm volatile("outl %%eax, %%dx" : : "a"(0x80000000 | id | offset), "d"(0xCF8));
	
	uint32_t ret;
	asm volatile("inl %%dx, %%eax" : "=a"(ret) : "d"(0xCFC));
	
	return ret;
}

void pci_write_1(uint32_t id, uint8_t offset, uint8_t val) {
	asm volatile("outl %%eax, %%dx" : : "a"(0x80000000 | id | offset), "d"(0xCF8));
	asm volatile("outb %%al, %%dx" : : "a"(val), "d"(0xCFC + (offset & 3)));
}

void pci_write_2(uint32_t id, uint8_t offset, uint16_t val) {
	asm volatile("outl %%eax, %%dx" : : "a"(0x80000000 | id | offset), "d"(0xCF8));
	asm volatile("outw %%ax, %%dx" : : "a"(val), "d"(0xCFC + (offset & 2)));
}

void pci_write_4(uint32_t id, uint8_t offset, uint32_t val) {
	asm volatile("outl %%eax, %%dx" : : "a"(0x80000000 | id | offset), "d"(0xCF8));
	asm volatile("outl %%eax, %%dx" : : "a"(val), "d"(0xCFC));
}