#include"ppm.h"

#include<stdint.h>

typedef struct __attribute__((packed)) {
	uint64_t start;
	uint32_t length;
	uint8_t flags;
	uint8_t data[];
} PPMBitmap;

PPMBitmap *ppm_Bitmap;

static int availability_test(PPMBitmap *bm, size_t pg, size_t len) {
	if(pg > bm->length - len) {
		return 0;
	}
	
	while(len--) {
		if(bm->data[pg / 8] & (1 << (pg % 8))) {
			return 0;
		}
		
		pg++;
	}
	
	return 1;
}

static int mark(PPMBitmap *bm, size_t pg, size_t len) {
	if(pg > bm->length - len) {
		return 0;
	}
	
	while(len--) {
		bm->data[pg / 8] |= 1 << (pg % 8);
		
		pg++;
	}
	
	return 1;
}

uint64_t ppm_alloc(size_t len) {
	PPMBitmap *bm = ppm_Bitmap;
	
	for(int bmid = 0; bmid < 2; bmid++) {
		if(bm->length < len) {
			continue;
		}
		
		for(size_t pg = 0; pg <= bm->length - len; pg++) {
			if(availability_test(bm, pg, len)) {
				if(mark(bm, pg, len)) {
					return bm->start + pg * 4096;
				}
			}
		}
		
		bm = (PPMBitmap*) ((uintptr_t) bm + sizeof(*bm) + (bm->length + 7) / 8);
	}
	
	return 0;
}
